-- A3Pv2/INC8_tb2.vhdl
-- version lun. nov. 13 01:42:14 CET 2017 by Yann Guidon (whygee@f-cpu.org)
-- version mar. oct. 30 07:20:24 CET 2018 : more suitable for individual gate delays
-- version mar. nov. 19 06:24:33 CET 2019 : forked from YGREC8/INC8_tb.vhdl
-- version jeu. nov. 21 07:01:36 CET 2019 : trace->flip generics change
-- Released under the GNU AGPLv3 license

Library ieee;
    use ieee.std_logic_1164.all;
    use ieee.numeric_std.all;
Library work;
    use work.all;
    use work.ygrec8_def.all;
    use work.ygrec8_utils.all;
-- added :
Library proasic3;
    use proasic3.all;

entity INC8_tb is
-- added :
  generic (
    -- for the A3P library :
    gate_select_number: integer := 0;  -- when >= 1, select a gate to alter
    bit_select_number: integer := -1;  -- select which input bit code to alter
    flip: integer := 0     -- set to 1 to alter 0/1 to meta L/H code (no bit flip of the LUT)
  );
end INC8_tb;

architecture plip of INC8_tb is
  signal V : SL := '0';
  signal A, Y : SLV8 := "00000000";
-- added :
  signal clock : std_logic := '0';
begin

-- added :
  -- this entity MUST be written first,
  -- at the very beginning of the toplevel file:
  rg: entity register_generics port map(
       gate_select_number => gate_select_number,
       bit_select_number => bit_select_number,
       flip_LUT=> flip, clock => clock);

  tb: entity INC8 port map (
     A => A,
     Y => Y,
     V => V);

  bench: process
    variable i: integer := 0;
    variable expected : SLV9;
  begin
-- added :
    if gate_select_number=-1 then
      wait;
    end if;

    for i in 0 to 255 loop
      A <= std_logic_vector(to_unsigned(i, 8));

-- added :
      clock <= '0';
      wait for 10 ns;
      clock <= '1';
      wait for 10 ns;

      expected := std_logic_vector(to_unsigned(i+1, 9));
      assert expected = (V & Y)
        report "Error at " & integer'image(i)
          & " " & SLV_to_bin(A)
          & " " & std_logic'image(V)
          & " " & SLV_to_bin(Y)
        severity failure;
    end loop;

-- added :
    clock<='X'; -- display the histogram
    wait;
  end process;

end plip;
